#
# Example 18-15
# The /debug/source application-direct URL implementation.
#

proc Debug/source {source} {
	global Httpd Doc
	set source [file tail $source]
	set dirlist $Httpd(library)
	if {[info exists Doc(templateLibrary)]} {
		lappend dirlist $Doc(templateLibrary)
	}
	foreach dir $dirlist {
		set file [file join $dir $source]
		if [file exists $file] {
			break
		}
	}
	set error [catch {uplevel #0 [list source $file]} result]
	set html "<title>Source $source</title>\n"
	if {$error} {
		global errorInfo
		append html "<H1>Error in $source</H1>\n"
		append html "<pre>$result<p>$errorInfo</pre>"
	} else {
		append html "<H1>Reloaded $source</H1>\n"
		append html "<pre>$result</pre>"
	}
	return $html
}


